/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package com.ryuuji.servlet.estudiante.anotacion;

import java.io.IOException;
import java.io.PrintWriter;
import javax.servlet.ServletException;
import javax.servlet.annotation.WebServlet;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import logica.ExNihilo;
import logica.Search;
import orm.Curso;
import orm.Estudiante;
import orm.Profesor;

/**
 *
 * @author ryuuji
 */
@WebServlet(name = "CrearAnotacion", urlPatterns = {"/CrearAnotacion"})
public class CrearAnotacion extends HttpServlet {

    /**
     * Processes requests for both HTTP <code>GET</code> and <code>POST</code> methods.
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    protected void processRequest(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        response.setContentType("text/html;charset=UTF-8");
        String descripcion = request.getParameter("descripcion");
        String tipo = request.getParameter("tipo");
        String profesorRut = request.getParameter("profesor");
        String estudianteRut = request.getParameter("estudianteCrear");
        String cursoString = request.getParameter("cursoCrear");
        if (!descripcion.equals("")) {
            if (!tipo.equals("")) {
                if (!profesorRut.equals("")) {
                    if (!estudianteRut.equals("")) {
                        if (!cursoString.equals("")) {
                            if (cursoString.matches("\\d+-\\w")) {
                                Profesor profesor = Search.buscarProfesor(profesorRut);
                                if (profesor != null) {
                                    Estudiante estudiante = Search.buscarEstudiante(estudianteRut);
                                    if (estudiante != null) {
                                        Curso curso = Search.buscarCurso(Integer.parseInt(cursoString.split("-")[0]), cursoString.split("-")[1]);
                                        if (curso != null) {
                                            if (tipo.equals("positiva")) {
                                                if (ExNihilo.crearAnotacion(true, descripcion, estudiante, profesor)) {
                                                    request.getRequestDispatcher("AnotacionesServlet").forward(request, response);
                                                } else {
                                                    request.setAttribute("errorCrear", "A ocurrido un error innesperado");
                                                    request.getRequestDispatcher("AnotacionesServlet").forward(request, response);
                                                }
                                            } else {
                                                if (ExNihilo.crearAnotacion(false, descripcion, estudiante, profesor)) {
                                                    request.getRequestDispatcher("AnotacionesServlet").forward(request, response);
                                                } else {
                                                    request.setAttribute("errorCrear", "A ocurrido un error innesperado");
                                                    request.getRequestDispatcher("AnotacionesServlet").forward(request, response);
                                                }
                                            }
                                        } else {
                                            request.setAttribute("errorCrear", "El curso no existe");
                                            request.getRequestDispatcher("AnotacionesServlet").forward(request, response);
                                        }
                                    } else {
                                        request.setAttribute("errorCrear", "El estudiante no existe");
                                        request.getRequestDispatcher("AnotacionesServlet").forward(request, response);
                                    }
                                } else {
                                    request.setAttribute("errorCrear", "El profesor no existe");
                                    request.getRequestDispatcher("AnotacionesServlet").forward(request, response);
                                }
                            } else {
                                request.setAttribute("errorCrear", "El cuso no es valido");
                                request.getRequestDispatcher("AnotacionesServlet").forward(request, response);
                            }
                        } else {
                            request.setAttribute("errorCrear", "No hay un curso seleccionado");
                            request.getRequestDispatcher("AnotacionesServlet").forward(request, response);
                        }
                    } else {
                        request.setAttribute("errorCrear", "No hay un estudiante seleccionado");
                        request.getRequestDispatcher("AnotacionesServlet").forward(request, response);
                    }
                } else {
                    request.setAttribute("errorCrear", "No hay un profesor seleccionado");
                    request.getRequestDispatcher("AnotacionesServlet").forward(request, response);
                }
            } else {
                request.setAttribute("errorCrear", "Debe ingresar un tipo");
                request.getRequestDispatcher("AnotacionesServlet").forward(request, response);
            }
        } else {
            request.setAttribute("errorCrear", "Debe ingresar una descripcion");
            request.getRequestDispatcher("AnotacionesServlet").forward(request, response);
        }
        request.getRequestDispatcher("AnotacionesServlet").forward(request, response);
    }

    // <editor-fold defaultstate="collapsed" desc="HttpServlet methods. Click on the + sign on the left to edit the code.">
    /**
     * Handles the HTTP <code>GET</code> method.
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doGet(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        processRequest(request, response);
    }

    /**
     * Handles the HTTP <code>POST</code> method.
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doPost(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        processRequest(request, response);
    }

    /**
     * Returns a short description of the servlet.
     *
     * @return a String containing servlet description
     */
    @Override
    public String getServletInfo() {
        return "Short description";
    }// </editor-fold>

}
